#include<stdio.h>
#include<time.h>
#define max_num 100
#define PRINT 0
void swap(int* a, int* b)
{
	int c;
	c=*a;
	*a=*b;
	*b=c;
}

int findPosition(int perm_str[],int perm_num,int black_num)
{
	int i,num=0;
	
	for(i=perm_num;i>0;i--)
	{
		if(0==perm_str[i])
		{
			num++;
			if(num==black_num+1)
				return i;
				
		}
	}
	return i;	
}

void increaseDic(int perm_dic[],int perm_num)
{
	int i;
	int tmp_sum;;
	int inc=1;

	for(i=perm_num-1;i>0;i--)
	{
		tmp_sum=perm_dic[i]+inc;
		
		if(tmp_sum<perm_num-i+1)
		{
			//stop
			perm_dic[i]=tmp_sum;
			break;
		}
		else
		{
			inc=1;
			perm_dic[i]=tmp_sum-(perm_num-i+1);
		}
	}
}


void printf_perm(int perm_str[],int perm_num)
{
	int i;
	for(i=1;i<=perm_num;i++)
		printf("%d ",perm_str[i]);
	printf("\n");
}


int main(int argc,char *argv[])
{
	clock_t start, end;
	int i,perm_all_num=0;
	int perm_dic[max_num+1];
	int perm_str[max_num+1];
	int sort_flag;
	int perm_num=atoi(argv[1]);
	int pre=0,next=0;
	if(perm_num>max_num || argc>2 ||perm_num<1)
	{
		printf("Too large");
		return 1;
		
	}
	
	start = clock();
	memset(perm_dic,0,(perm_num+1)*sizeof(int));
	memset(perm_str,0,(perm_num+1)*sizeof(int));
	
	
	while(next>=pre)
	{
	
		for(i=1;i<=perm_num;i++)
		{
			int current_num=perm_num-i+1;
			int black_num=perm_dic[i];
		
			int index=findPosition(perm_str,perm_num,black_num);
		
	
			perm_str[index]=current_num;
		}
	
		pre=perm_dic[1];
		if(PRINT)
			printf_perm(perm_str,perm_num);
		perm_all_num++;
		
		memset(perm_str,0,(perm_num+1)*sizeof(int));
	
		increaseDic(perm_dic,perm_num);
		
		next=perm_dic[1];
	
	}
	end = clock();
	printf("%f\n", difftime(end, start));
	printf("%d\n",perm_all_num);
	return 0;
	
	
}
