#include<stdio.h>
#include<time.h>
#define max_num 100

#define PRINT 0
void swap(int* a, int* b)
{
	int c;
	c=*a;
	*a=*b;
	*b=c;
}

void inverse(int perm_str[],int index,int perm_num)
{
	int mid=(index+perm_num)/2;
	int i,j;
	
	for(i=index;i<=mid;i++)
		swap(&perm_str[i],&perm_str[perm_num-(i-index)]);
}

int findlarger(int perm_str[],int perm_num,int index)
{
	int i,larger_index=0,tmp_index;
	for(i=index+1;i<=perm_num;i++)
	{
		if(perm_str[i]>perm_str[index])
		{
			tmp_index=i;
			
			if(perm_str[tmp_index<perm_str[larger_index]])
				larger_index=tmp_index;
				
		}
		
	}
	return larger_index;
}


void printf_perm(int perm_str[],int perm_num)
{
	int i;
	for(i=1;i<=perm_num;i++)
		printf("%d ",perm_str[i]);
	printf("\n");
	int p=perm_num+1;
	for(i=1;i<=perm_num;i++)
		printf("%d ",p-perm_str[i]);
	printf("\n");
}


int getPerm_n(int n)
{
	if(n==1 || n==0)
		return 1;
	else
		return n*getPerm_n(n-1);
}
int main(int argc,char *argv[])
{
	clock_t start, end;
	int i,perm_all_num=0;
	int perm_str[max_num+1];
	int sort_flag;
	int perm_num=atoi(argv[1]);
	int improved_n=2;
	if(perm_num>max_num || argc>2 ||perm_num<1)
	{
		printf("Too large");
		return 1;
		
	}
	if(perm_num==1)
	{
		printf("1\n");
		return 0;
	}
	start = clock();
	perm_str[0]=perm_num;
	for(i=1;i<=perm_num;i++)//can improve
		perm_str[i]=i;
	
	if(PRINT)
		printf_perm(perm_str,perm_num);
	perm_all_num=getPerm_n(perm_num)/improved_n;
	sort_flag=1;
	int p=perm_num-1;
	while(sort_flag<perm_all_num)
	{
		for(i=p;i>0;i--)
		{
			if(perm_str[i]<perm_str[i+1])
			{
				sort_flag++;
				//find lager than this
				int larger_index=findlarger(perm_str,perm_num,i);
			
				//swap
				swap(&perm_str[i],&perm_str[larger_index]);
			

				//inverse		
				inverse(perm_str,i+1,perm_num);
				if(PRINT)
					printf_perm(perm_str,perm_num);		
				break;
			}
		}
	}

	end = clock();
	printf("time:%f\n", difftime(end, start));
	printf("perm num is %d\n",perm_all_num*2);

	return 0;
}
